

class Inheriter{
    constructor(pageKey,callbackUrl,uuid,returnUrl,editmode,token) {
        this.pageKey = pageKey
        this.callbackUrl = callbackUrl
        this.uuid = uuid
        this.returnUrl = returnUrl
        this.editmode = editmode;
        this.token = token



        this.rootAreas = []
        this.selectors={
            rootArea: '.opc-rootarea',
            subArea: '.opc-area',
            portlet:':scope > [data-portlet]'


        }
    }
    editChild(){

        const savebuttondiv = window.parent.document.getElementById('savePublishButtons')
        let btnClone = document.getElementById('btnClone');
        let btnBlueprint = document.getElementById('btnBlueprint');
        let btnParent = document.getElementById('btnParent');
        let portlets = document.querySelectorAll('[data-portlet]')

        portlets.forEach(p=>{
            if(p.className.includes('dzm-master') || p.className.includes('dzm-parent')|| p.className.includes('dzm-child')|| p.className.includes('dzm-touched')){
                p.addEventListener('click',()=>{
                    console.log('master clicked')
                    btnClone.disabled = true
                    btnClone.style.color = '#00000033'
                    btnParent.disabled = true
                    btnParent.style.color = '#00000033'
                    btnBlueprint.disabled = true
                    btnBlueprint.style.color = '#00000033'
                })

            }else{
                p.addEventListener('click',()=>{
                    console.log('no master clicked')
                    btnClone.disabled = false
                    btnClone.style.color = 'unset'
                    btnParent.disabled = false
                    btnParent.style.color = 'unset'
                    btnBlueprint.disabled = false
                    btnBlueprint.style.color = 'unset'
                })
            }
        })



        let head = document.getElementsByTagName('head')[0]
        let style = document.createElement('style')
        style.innerHTML = `
            [data-portlet][class*="dzm-master"] {
               border: unset !important;
                margin: unset !important;
                /*pointer-events:none;*/
                opacity: 0.5
            }
            [data-portlet][class*="dzm-master"] .opc-droptarget{
                display:none;
            }
            `;
        head.appendChild(style)

    }
    edit(templateType){


        //console.log(window)
        //console.log(window.top)
        //console.log(window.parent)
        if(this.editmode){

            localStorage.removeItem('editMaster')


            let body = document.querySelector('body')
            body.dataset.inheriter = 'e'
            let beforeFooter = document.querySelector("[data-area-id=\"dzmopcplus_before_footer\"]")
            let afterFooter = document.querySelector("[data-area-id=\"dzmopcplus_after_footer\"]")
            let beforeTopbar = document.querySelector("[data-area-id=\"dzmopcplus_before_topbar\"]")
            let afterTopbar = document.querySelector("[data-area-id=\"dzmopcplus_after_topbar\"]")
            let beforeInheriterFooter = document.querySelector("[data-area-id=\"dzmopcinheriter_before_footer\"]")
            let afterInheriterFooter = document.querySelector("[data-area-id=\"dzmopcinheriter_after_footer\"]")
            switch (templateType){
                case 'product':
                    body.innerHTML = document.getElementById('main-wrapper').outerHTML
                    break;
                case 'category':
                    body.innerHTML = document.getElementById('main-wrapper').outerHTML
                    break;
                case 'page':
                    body.innerHTML = document.getElementById('main-wrapper').outerHTML
                    break;

                case 'header':
                    document.getElementById('main-wrapper').remove()
                    document.getElementById('footer').remove()

                    if(beforeFooter){
                        beforeFooter.remove()
                    }
                    if(afterFooter){
                        afterFooter.remove()
                    }
                    if(beforeInheriterFooter){
                        //beforeInheriterFooter.remove()
                    }
                    if(afterInheriterFooter){
                        //afterInheriterFooter.remove()
                    }
                    break;
                case 'footer':
                    document.getElementById('main-wrapper').remove()
                    document.getElementsByTagName('header')[0].remove()
                    if(beforeTopbar){
                        beforeTopbar.remove()
                    }
                    if(afterTopbar){
                        afterTopbar.remove()
                    }
                    /*let upperFooter = ''
                    let lowerFooter = ''
                    let upperInheriterFooter = ''
                    let lowerInheriterFooter = ''
                    if(beforeFooter){
                        upperFooter = beforeFooter.outerHTML
                    }
                    if(afterFooter){
                        lowerFooter = afterFooter.outerHTML
                    }

                    if(beforeInheriterFooter){
                        upperInheriterFooter = beforeInheriterFooter.outerHTML
                    }
                    if(afterInheriterFooter){
                        lowerInheriterFooter = afterInheriterFooter.outerHTML
                    }

                    let mainFooter = document.getElementById('footer').outerHTML
                    body.innerHTML = upperFooter + upperInheriterFooter + lowerFooter + lowerInheriterFooter + mainFooter*/

                    break;
                default:
                    console.error('unknown type',type)
                    break;

            }


            const button = window.parent.document.querySelector('.opc-btn-primary')
            button.remove()



            const savebuttondiv = window.parent.document.getElementById('savePublishButtons')
            const savebutton = savebuttondiv.getElementsByClassName('opc-btn-secondary')[0]

            savebutton.textContent = 'Master-Template speichern'
            savebutton.setAttribute('style','background:#9538F1!important;width:100%!important;color:white;border:none!important;')

            let head = document.getElementsByTagName('head')[0]
            let style = document.createElement('style')
            style.innerHTML = `
            [data-portlet][class*="dzm-master"] {
                   border: 2px solid #9538F1!important;

            }
            `;
            head.appendChild(style)




        }








    }
    async save(){
        console.log('Speichere Master')

        let areas = {}

        this.rootAreas = document.querySelectorAll(this.selectors.rootArea)

        this.rootAreas.forEach(area=>{


            areas[area.dataset.areaId] = {
                id: area.dataset.areaId,
                content:[]
            }
            let portlets = area.querySelectorAll(this.selectors.portlet)
            portlets.forEach(portlet=>{

                let portletData = JSON.parse(portlet.dataset.portlet)
                if(!portletData.properties)
                    portletData.properties = {}
                if(!portletData.properties['custom-class'])
                    portletData.properties['custom-class'] = 'dzm-major-'+this.uuid+'-'+this.uid()
                if(portletData.properties['custom-class'].includes('dzm-major')){
                    //const regex = /dzm-major-[a-z0-9]*-[a-z0-9]*/i;
                    //portletData.properties['custom-class'] = portletData.properties['custom-class'].replace(regex, 'dzm-major-'+this.uuid+'-'+this.uid());
                }else{
                    portletData.properties['custom-class'] +=' dzm-major-'+this.uuid+'-'+this.uid()

                }

                portletData.subareas = this.getSubAreas(portlet)

                areas[area.dataset.areaId].content.push(portletData)
            })
        })

        const body = {
            pageKey:this.pageKey,
            areas:areas,
            uuid:this.uuid,
            jtlToken:this.token
        }
        console.log('body',body)
        let res = await fetch(decodeURIComponent(this.callbackUrl),
            {
                method:'POST',
                headers:{
                    'Content-Type':'application/json'
                },
                body:JSON.stringify(body)
            })
        let response = await res.json()
        if(response.status === 'success'){
            localStorage.removeItem('opcpage.'+this.pageKey)
            console.log('success')
            window.parent.location.href = this.returnUrl

        }else{
            console.error('sux',response)
        }

    }

    getSubAreas(portlet){
        let areas;

        let subRootArea = portlet.querySelector(this.selectors.subArea)



        if(subRootArea){
            areas={}


            areas[subRootArea.dataset.areaId] = {
                id:subRootArea.dataset.areaId,
                content:[]
            }
            let subPortlets = subRootArea.querySelectorAll(this.selectors.portlet)

            subPortlets.forEach(subPortlet=>{

                let subPortletData = JSON.parse(subPortlet.dataset.portlet)

                if(!subPortletData.properties)
                    subPortletData.properties = {}
                if(!subPortletData.properties['custom-class'])
                    subPortletData.properties['custom-class'] = 'dzm-major-'+this.uuid+'-'+this.uid()
                if(subPortletData.properties['custom-class'].includes('dzm-major')){
                    //const regex = /dzm-major-[a-z0-9]*-[a-z0-9]*/i;
                    //subPortletData.properties['custom-class'] = subPortletData.properties['custom-class'].replace(regex, 'dzm-major-'+this.uuid+'-'+this.uid());
                }else{
                    subPortletData.properties['custom-class'] +=' dzm-major-'+this.uuid+'-'+this.uid()

                }

                subPortletData.subareas = this.getSubAreas(subPortlet)

                areas[subRootArea.dataset.areaId].content.push(subPortletData)
            })

        }else{
            areas = []
        }

        // [] oder {dzm-section:{...}}
        return areas

    }

    uid(){
        let dt = new Date().getTime();
        let uid = 'xxxxxyxx'.replace(/[xy]/g, function(c) {
            let r = (dt + Math.random()*16)%16 | 0;
            dt = Math.floor(dt/16);
            return (c==='x' ? r :(r&0x3|0x8)).toString(16);
        });
        return uid;
    }
}
document.addEventListener('DOMContentLoaded',()=>{
    let params = (new URL(window.parent.location)).searchParams

    if(params.get('dzmedit')){
        let inheriter = new Inheriter(params.get('pageKey'),params.get('callbackUrl'),params.get('uuid'),params.get('returnUrl'),params.get('dzmedit'), params.get('token'))

        inheriter.edit(params.get('dzmEditType'))
    }else if(window.parent.location.pathname.includes('admin/onpagecomposer')){
        setTimeout(()=>{
            let inheriter = new Inheriter('','','','','','')

            inheriter.editChild()
        },1000)

    }


})




